#include "ShortestPath.h"

ShortPath SPath;						

int main(int argc, char* argv[])
{
	//
	// Initialization graph (adjacency matrix representation of graph)
	//
	GraphMatrix Graph = 
						{
							{
						 		{   0,  50,  10, MAX,  45, MAX},
								{ MAX,   0,  15, MAX,   5, MAX},
								{  20, MAX,   0,  15, MAX, MAX},
								{ MAX,  20, MAX,   0,  35, MAX},
								{ MAX, MAX, MAX,  30,   0, MAX},
								{ MAX, MAX, MAX,   3, MAX,   0}
							}
						};
						
	//
	// Shortest path (Floyd algorithm)
	//	
	Floyd(&Graph, &SPath);
	
	//
	// output result
	//	
	OutputResult(&SPath);
	
	return 0;
}

/*
function:
	The Floyd algorithm for shortest paths

parameter:
	pPath -- Structure pointer
	pGraph -- Figure pointer
*/
void Floyd(GraphMatrix* pGraph, ShortPath* pPath)
{
	int i, j, k;	// The cursor
		
	//
	// TODO: Add the code here
	//
		
}

/*
function:
	output result

parameter:
	nothing
*/
void OutputResult(ShortPath* pPath)
{
	int i, j;
	
	printf("Subsequent vertex index array:\n");
	for (i = 0; i < VERTEXNUM; i++)
	{
		for (j = 0; j < VERTEXNUM; j++)
		{
			printf("%d ", pPath->nextvex[i][j]);
		}
		printf("\n");
	}
	
	printf("An array of shortest path lengths between vertices:\n");
	for (i = 0; i < VERTEXNUM; i++)
	{
		for (j = 0; j < VERTEXNUM; j++)
		{
			if (pPath->a[i][j] == MAX)
			{
				printf("MAX ");
			}
			else
			{
				printf("%d ", pPath->a[i][j]);
			}			
		}
		printf("\n");
	}				
}

